<script type="text/javascript">

$(function() {

	if (typeof docCookies === 'undefined') { // OpenCms 9.0.1 doesn't load headincludes when you drop an element in a group (never works online; works on second reload in offline)
		console.warn("Headincludes missing. OpenCms 9.0.1 doesn't load headincludes when you drop an element in a group (never works online; works on second reload in offline).");
		location.reload(); // since we are offline, a reload will fix the missing headincludes.
	}
	console.log("cookies: lr="+docCookies.getItem('<%=COOKIE_LIVE_RELOAD%>')+" ap="+docCookies.getItem('<%=COOKIE_AUTO_PUBLISH%>')+" so="+docCookies.getItem('<%=COOKIE_STAY_OPEN%>')+" sl="+docCookies.getItem('<%=COOKIE_HORIZONTAL_LAYOUT%>'));

	var cookies = {"<%=COOKIE_LIVE_RELOAD%>":true, "<%=COOKIE_AUTO_PUBLISH%>":false, "<%=COOKIE_STAY_OPEN%>":false, "<%=COOKIE_HORIZONTAL_LAYOUT%>":true};
	jQuery.each(cookies, function(cookieName, defaultValue) {
		console.log("cookie = "+cookieName+" "+defaultValue);
		if (!docCookies.hasItem(cookieName)) docCookies.setItem(cookieName, defaultValue, Infinity,'/');
	});

	var cookies = ["<%=COOKIE_LIVE_RELOAD%>", "<%=COOKIE_AUTO_PUBLISH%>", "<%=COOKIE_STAY_OPEN%>"];
	jQuery.each(cookies, function(index, cookieName) {
		$('#set'+cookieName).prop('checked',docCookies.getItem(cookieName)==='true');
	});

	var cookies = ["<%=COOKIE_AUTO_PUBLISH%>", "<%=COOKIE_STAY_OPEN%>"];
	jQuery.each(cookies, function(index, cookieName) {
		$('#set'+cookieName).click(function() {
			docCookies.setItem(cookieName, $(this).is(':checked'), Infinity,'/');
		});
	});

	if ($.parseJSON(docCookies.getItem('<%=COOKIE_LIVE_RELOAD%>'))) {
		jQuery.getScript("http://${pageContext.request.serverName}:${content.value.ReloadPort}/livereload.js");
	}
	$('.glide-panel').toggleClass( "open" , docCookies.getItem('<%=COOKIE_STAY_OPEN%>')==='true');
	$('.glide-panel').toggleClass( "horizontal" , docCookies.getItem('<%=COOKIE_HORIZONTAL_LAYOUT%>')==='true');

	$('.open-panel').click(function(){
		$('.glide-panel').toggleClass( "open" );
	});
	$('.layout-mode').click(function(){
		$('.glide-panel').toggleClass( "horizontal" );
		docCookies.setItem("<%=COOKIE_HORIZONTAL_LAYOUT%>", $('.glide-panel').hasClass('horizontal'), Infinity,'/');
	});

	$('#set<%=COOKIE_LIVE_RELOAD%>').click(function() {
		docCookies.setItem('<%=COOKIE_LIVE_RELOAD%>', $(this).is(':checked'), Infinity,'/');
		if ($(this).is(':checked')) {
			location.reload();
		} else {
			if(typeof window.LiveReload !== 'undefined') window.LiveReload.shutDown();
		}
	});

	function updateLog() {
		$.get("<cms:link>/system/modules/it.teamquality.glide/elements/grunt-output-snippet.jsp</cms:link>", function (result) {
			$('#log').html(result);
			$("#log").scrollTop($("#log")[0].scrollHeight);
		});
	};
	updateLog();
	setInterval(updateLog, 5000); // ToDo: implement log updates with a websocket

	toggleRunButtons(<%=isGruntRunning(request)%>);

});

function runnerFormSubmit(action) { // we submit this via AJAX because otherwise it would be resubmitted on auto-reload
	console.log("runner form action: "+action);
	$("#gruntRunnerForm input[name='<%=PARAM_GRUNT_NAME%>']").val(action);
	$.ajax({
		type: "POST",
		url: "<cms:link>/system/modules/it.teamquality.glide/elements/grunt-runner.jsp</cms:link>",
		data: $("#gruntRunnerForm").serialize(), // serializes the form's elements.
		success: function(data) {
			if ($.parseJSON(data) && ($.parseJSON(docCookies.getItem('<%=COOKIE_LIVE_RELOAD%>')))) {
                console.log("Grunt started, need to reload to enable liveReload");
                //$("#gruntRunnerForm").hide(5000);
                $("#glide-loading").show();
                setTimeout(function(){location.reload();},9000); // to enable liveReload, we need to reload after Grunt has started
            };
            toggleRunButtons($.parseJSON(data));
		}
	});
	return false; // avoid to execute the actual submit of the form
};

function toggleRunButtons(running) {
	if (running) {
		$('button.start').attr('disabled','disabled');
		$('button.start').addClass('disabled');
		$('button.stop').removeAttr('disabled');
		$('button.stop').removeClass('disabled');
	} else {
		$('button.stop').attr('disabled','disabled');
		$('button.stop').addClass('disabled');
		$('button.start').removeAttr('disabled');
		$('button.start').removeClass('disabled');
	};
};

</script>