module.exports = function (grunt) {
	grunt.loadNpmTasks('grunt-contrib-uglify');
	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-contrib-compass');
	grunt.loadNpmTasks('grunt-contrib-cssmin');
	

 grunt.log.writeln('Time: '+grunt.template.today("yyyy-mm-dd HH:MM:ss"));
 grunt.log.writeln('moduleName='+grunt.option('moduleName'));
 grunt.log.writeln('outputStyle='+grunt.option('outputStyle'));
 grunt.log.writeln('environment='+grunt.option('environment'));
 grunt.log.writeln('reloadPort='+grunt.option('reloadPort'));
 
	grunt.initConfig ({
		path: '<%= grunt.option("moduleName") %>',
		pkg: grunt.file.readJSON('package.json'),
		
		uglify: {
			options: {
				banner: '/*! <%= pkg.name %> <%= grunt.template.today("yyyy-mm-dd") %> */\n'
			},
			my_target: {
				files: [{
					expand: true,
					cwd: '<%= path %>resources/js/',
					src: ['*.js', '!*.min.js'],
					dest: '<%= path %>resources/js/',
					ext: '.min.js'
				}]
			}
		},  // uglify

		cssmin: {
			my_target: {
				files: [{
					expand: true,
					cwd: '<%= path %>resources/css/',
					src: ['*.css', '!*.min.css'],
					dest: '<%= path %>resources/css/',
					ext: '.min.css'
				}]
			}
		},  // cssmin

		
		compass: {
			dev: {
				options: {
					//config: '<%= path %>config.rb',
					config: 'config.rb',
					cssDir: '<%= path %>resources/css',
					sassDir: '<%= path %>resources/scss',
					imagesDir: '<%= path %>resources/img',
					javascriptsDir: '<%= path %>resources/js',
					outputStyle:'<%= grunt.option("outputStyle") %>',
					environment:'<%= grunt.option("environment") %>',
					relativeAssets:true,
				}//options
			}//dev
		},
		watch: {
			
			options: {
				livereload: {
					port: '<%= grunt.option("reloadPort") %>',
				}
			},
			scripts: {
				files: ['<%= path %>resources/js/*.js'],
				tasks: ['uglify:my_target']
			}, //script
			sass: {
				files: ['<%= path %>resources/scss/*.scss'],
				tasks: ['compass:dev','cssmin:my_target']
			}, //sass
			html: {
				files: ['<%= path %>templates/*.html','<%= path %>templates/*.jsp','<%= path %>elements/*.jsp','<%= path %>formatters/*.jsp'],
			}
		}
	}) //initConfig
	grunt.registerTask('default', 'watch')
}



